﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectGarage.Entities;

public class FuelReplenishment 
{ 
    public int Id { get; private set; }

    [Browsable(false)]
    public int DriverId { get; private set; }

    [DisplayName("Водитель")]
    public string DriverName { get; private set; } = string.Empty;

    [DisplayName("Дата поставки")]
    public DateTime ReplenishmentDate { get; private set; }

    [DisplayName("Топлива")]
    public string Fuel => FuelFuelReplenishments != null ?
string.Join(", ", FuelFuelReplenishments.Select(x => $"{x.FuelName} {x.Amount}")) : string.Empty;

    [Browsable(false)]
    public IEnumerable<FuelFuelReplenishment> FuelFuelReplenishments { get; private set;} = [];

   
    public static FuelReplenishment CreateOpeartion(int id, int driverId, IEnumerable<FuelFuelReplenishment> fuelFuelReplenishments)
    {
        return new FuelReplenishment
        {
            Id = id,
            DriverId = driverId,
            ReplenishmentDate = DateTime.Now,
            FuelFuelReplenishments = fuelFuelReplenishments
        };
    }

    public void SetFuelFuelReplenishments(IEnumerable<FuelFuelReplenishment> fuelFuelReplenishments)
    {
        if (fuelFuelReplenishments != null && fuelFuelReplenishments.Any())
        {
            FuelFuelReplenishments = fuelFuelReplenishments;
        }
    }
}
